﻿using Syncfusion.HtmlConverter;
using Syncfusion.Pdf;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;

namespace HTMLtoPDF_WcfService
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    // NOTE: In order to launch WCF Test Client for testing this service, please select Service1.svc or Service1.svc.cs at the Solution Explorer and start debugging.
    public class Service1 : IService1
    {
        public string GeneratePdf(string value)
        {
            
            HtmlToPdfConverter htmlConverter = new HtmlToPdfConverter(HtmlRenderingEngine.WebKit);
            
            WebKitConverterSettings webKitSettings = new WebKitConverterSettings();

            webKitSettings.Margin.All = 20;

            webKitSettings.WebKitViewPort = new System.Drawing.Size(1024,0);

            htmlConverter.ConverterSettings = webKitSettings;

            //Convert url to pdf
            PdfDocument document = htmlConverter.Convert(value);

            //Save the document
            MemoryStream stream = new MemoryStream();
            //Saves the Pdf document to stream
            document.Save(stream);
            //Sets the stream position
            stream.Position = 0;
            document.Close();
            //Returns the stream data as Base 64 string
            return Convert.ToBase64String(stream.ToArray());
        }
    }
}
